/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

class Fp @JvmOverloads constructor(
    @field:Transient private var swigCPtr: Long = MclJNI.new_Fp__SWIG_0(),
    @field:Transient protected var swigCMemOwn: Boolean = true
) {
    protected fun finalize() {
        delete()
    }

    @Synchronized
    fun delete() {
        if (swigCPtr != 0L) {
            if (swigCMemOwn) {
                swigCMemOwn = false
                MclJNI.delete_Fp(swigCPtr)
            }
            swigCPtr = 0
        }
    }

    constructor(rhs: Fp?) : this(MclJNI.new_Fp__SWIG_1(getCPtr(rhs), rhs), true) {}
    constructor(x: Int) : this(MclJNI.new_Fp__SWIG_2(x), true) {}
    constructor(str: String?, base: Int) : this(MclJNI.new_Fp__SWIG_3(str, base), true) {}
    constructor(str: String?) : this(MclJNI.new_Fp__SWIG_4(str), true) {}

    fun equals(rhs: Fp?): Boolean {
        return MclJNI.Fp_equals(swigCPtr, this, getCPtr(rhs), rhs)
    }

    val isZero: Boolean
        get() = MclJNI.Fp_isZero(swigCPtr, this)
    val isOne: Boolean
        get() = MclJNI.Fp_isOne(swigCPtr, this)

    fun setStr(str: String?, base: Int) {
        MclJNI.Fp_setStr__SWIG_0(swigCPtr, this, str, base)
    }

    fun setStr(str: String?) {
        MclJNI.Fp_setStr__SWIG_1(swigCPtr, this, str)
    }

    fun setInt(x: Int) {
        MclJNI.Fp_setInt(swigCPtr, this, x)
    }

    fun clear() {
        MclJNI.Fp_clear(swigCPtr, this)
    }

    fun setByCSPRNG() {
        MclJNI.Fp_setByCSPRNG(swigCPtr, this)
    }

    fun toString(base: Int): String? {
        return MclJNI.Fp_toString__SWIG_0(swigCPtr, this, base)
    }

    override fun toString(): String {
        return MclJNI.Fp_toString__SWIG_1(swigCPtr, this)!!
    }

    fun deserialize(cbuf: ByteArray?) {
        MclJNI.Fp_deserialize(swigCPtr, this, cbuf)
    }

    fun serialize(): ByteArray? {
        return MclJNI.Fp_serialize(swigCPtr, this)
    }

    companion object {
        fun getCPtr(obj: Fp?): Long {
            return obj?.swigCPtr ?: 0
        }
    }
}